# SharepointApi

Welcome to your new gem! In this directory, you'll find the files you need to be able to package up your Ruby library into a gem. Put your Ruby code in the file `lib/sharepoint_api`. To experiment with that code, run `bin/console` for an interactive prompt.

TODO: Delete this and the text above, and describe your gem

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'sharepoint_api'
```

And then execute:

    $ bundle install

Or install it yourself as:

    $ gem install sharepoint_api

## Usage

With the appropriate environmental variables set run this in a ruby console.
Run `bin/console` (after running `bundle install`) to get a pre-loaded ruby console.

```ruby
load 'lib/sharepoint_api.rb'

api = SharepointApi.new(
  host: ENV['SHAREPOINT_HOST'],
  site_name: ENV['SHAREPOINT_SITE'],
  library_name: ENV['SHAREPOINT_LIBRARY_NAME'],
  username: ENV['SHAREPOINT_USERNAME'],
  password: ENV['SHAREPOINT_PASSWORD'],
  ntlm: true # for SharePoint 2013, false otherwise
)

api.fetch_content_types # or whatever method you want to test.
```

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

> NOTE: run `bundle install` and commit the changes to the Gemfile.lock before deploying a new version.

## Testing

Start the test suite watcher:
`bundle exec guard`

Run the tests for just one file just enter the filename in the Guard console.
`spec/sharepoint_api/items_spec.rb`

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/anlek/sharepoint_api. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [code of conduct](https://github.com/anlek/sharepoint_api/blob/master/CODE_OF_CONDUCT.md).

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the SharepointApi project's codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/anlek/sharepoint_api/blob/master/CODE_OF_CONDUCT.md).
