[XXXXX](https://proof-tech.atlassian.net/browse/XXXXX)

### Overview

Please include a summary of the changes in this pull request.
List any dependencies that are required before this change is applied.

### Solution

How did you solve the problem?
Call out any particular implementation choices or design decisions you made

### Screenshots

[insert screenshots here]

### Testing Instructions

Describe, for your colleagues, how they can test your code locally on their system

### Pre-Merge Checklist

- [ ] I have updated the version and changelog in a different PR than bug fixes and features.
- [ ] The work here reflects the user stories in the JIRA ticket(s) listed at the top of this pull request
- [ ] This pull request has been referenced via URL in the JIRA ticket(s) listed
- [ ] I have performed a self-review of the code I have written here
- [ ] I have done end-to-end QA testing of sections of the code I have altered
- [ ] My changes generate no new warnings / errors in the console
- [ ] I have written/updated Ruby tests for the areas of the code base that I have modified
- [ ] I am prepared for this code to go to production today (or there is a WIP label on the pull request)
- [ ] I am prepared to write hotfixes or rollback my code if something goes wrong

### Gem Deployment Instructions

1. `bundle exec rake install`
2. `bundle exec rake release`

Reminder that deploy instructions are in the [here](https://github.com/proofgov/sharepoint_api#development).
