require_relative 'lib/sharepoint_api/version'

Gem::Specification.new do |spec|
  spec.name          = 'sharepoint_api'
  spec.version       = SharepointApi::VERSION
  spec.authors       = ['Andrew Kalek', 'Marlen Brunner', 'Danella Olsen']
  spec.email         = ['akalek@proofgov.com', 'mbrunner@proofgov.com', 'dolsen@proofgov.com']

  spec.summary       = 'SharepointApi allows you to interact with sharepoint in a simpler DSL.'
  spec.description   = 'A tool to make it easier to talk to sharepoint (via the proof-sharepoint-ruby gem)'
  spec.homepage      = 'https://github.com/proofgov/sharepoint_api'
  spec.license       = 'MIT'
  spec.required_ruby_version = Gem::Requirement.new('>= 2.6.0')

  spec.metadata['homepage_uri'] = spec.homepage
  spec.metadata['source_code_uri'] = 'https://github.com/proofgov/sharepoint_api'
  spec.metadata['changelog_uri'] = 'https://github.com/proofgov/sharepoint_api/blob/master/CHANGELOG.md'

  spec.add_runtime_dependency('addressable', '~> 2.7')
  spec.add_runtime_dependency('proof-sharepoint-ruby', '~> 2.0')

  # Specify which files should be added to the gem when it is released.
  # The `git ls-files -z` loads the files in the RubyGem that have been added into git.
  spec.files = Dir.chdir(File.expand_path(__dir__)) do
    `git ls-files -z`.split("\x0").reject { |f| f.match(%r{^(test|spec|features)/}) }
  end
  spec.bindir = 'bin'
  spec.executables = spec.files.grep(%r{^bin/}) { |f| File.basename(f) }

  spec.require_paths = ['lib']
end
